/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifdef SYMBIAN_BACKEND_USE_CNTMODEL_V2

#ifndef TRANSFORMPRESENCE_H
#define TRANSFORMPRESENCE_H

#include "cnttransformcontactdata.h"

QTM_USE_NAMESPACE

class CntTransformPresence : public CntTransformContactData
{
public:
    CntTransformPresence();
    
protected:
	QList<CContactItemField *> transformDetailL(const QContactDetail &detail);
	QContactDetail *transformItemField(const CContactItemField& field, const QContact &contact);
	QList<TUid> supportedFields() const;
	bool supportsDetail(QString detailName) const;
	QList<TUid> supportedSortingFieldTypes(QString detailFieldName) const;
    bool supportsSubType(const QString& subType) const;
    quint32 getIdForField(const QString& fieldName) const;
    void detailDefinitions(QMap<QString, QContactDetailDefinition> &definitions, const QString& contactType) const;
    void reset();

private:
    QContactPresence::PresenceState decodePresence(QString presence);
    
private:
    quint32 m_detailCounter;
};

#endif // TRANSFORMPRESENCE_H

#endif // SYMBIAN_BACKEND_USE_CNTMODEL_V2
