/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the QtDeclarative module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/
#include "qdeclarativeorganizercollection_p.h"
/*!
    \qmlclass Collection QDeclarativeOrganizerCollection

    \brief The Collection element represents a collection of items in an organizer manager.

    \ingroup qml-organizer
    \since Mobility 1.1


  \sa QOrganizerCollection

  The Collection element is part of the \bold{QtMobility.organizer 1.1} module.
*/

/*!
  \qmlproperty int Collection::collectionId
  \since Mobility 1.1

  This property holds the id of the collection.
  This property is read only.
  */

/*!
  \qmlproperty string Collection::name
  \since Mobility 1.1

  This property holds the name meta data of a collection.
  */

/*!
  \qmlproperty string Collection::description
  \since Mobility 1.1

  This property holds the description meta data of a collection.
  */

/*!
  \qmlproperty color Collection::color
  \since Mobility 1.1

  This property holds the color meta data of a collection.
  */

/*!
  \qmlproperty url Collection::image
  \since Mobility 1.1

  This property holds the image url meta data of a collection.
  */
