/****************************************************************************
**
** Copyright (C) 2011 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:LGPL$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this
** file. Please review the following information to ensure the GNU Lesser
** General Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU General
** Public License version 3.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of this
** file. Please review the following information to ensure the GNU General
** Public License version 3.0 requirements will be met:
** http://www.gnu.org/copyleft/gpl.html.
**
** Other Usage
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef S60VIDEOWINDOWDISPLAY_H
#define S60VIDEOWINDOWDISPLAY_H

#include "s60videodisplay.h"

QT_USE_NAMESPACE

class S60VideoWindowDisplay : public S60VideoDisplay
{
public:
    S60VideoWindowDisplay(QObject *parent);
    ~S60VideoWindowDisplay();

    // S60VideoDisplay
    WId winId() const;
    QRect extentRect() const;
    void setFrame(const CFbsBitmap &bitmap);

    void setWinId(WId id);
    void setDisplayRect(const QRect &rect);
    QRect displayRect() const;
    void repaint();
    void refreshDisplay();

private:
    WId m_winId;
    QRect m_displayRect;
    CFbsBitmap *m_bitmap;
};

#endif // S60VIDEOWINDOWDISPLAY_H

